/*
 * PuTTY miscellaneous BTRON stuff
 */

#include <basic.h>
#include <tstring.h>
#include <btron/event.h>
#include <btron/file.h>
#include "putty.h"

long tickcount_offset = 0;

unsigned long getticks(void)
{
  UW time;
  get_etm(&time);
  return time;
}

const char platform_x11_best_transport[] = "localhost";

void platform_get_x11_auth(char *display, int *proto,
                           unsigned char *data, int *datalen)
{
  /* We don't support this at all under BTRON. */
}

char *platform_get_x_display(void) {
  return NULL;
}

Filename platform_default_filename(const char *name)
{
  Filename ret;
  ret.tag = FILENAME_LINKNAME;
  ret.path[0] = TNULL;
  return ret;
}

char *platform_default_s(const char *name)
{
    if (!strcmp(name, "SerialLine"))
	return dupstr("/dev/ttyS0");
    return NULL;
}

int platform_default_i(const char *name, int def)
{
    if (!strcmp(name, "CloseOnExit"))
	return 2;  /* maps to FORCE_ON after painful rearrangement :-( */
    if (!strcmp(name, "WinNameAlways"))
	return 0;  /* X natively supports icon titles, so use 'em by default */
    return def;
}

const char *filename_to_str(const Filename *fn)
{
  W err;

  switch (fn->tag) {
      case FILENAME_LINKNAME:
        tcstoeucs(fn->filename_tmp, fn->path);
        return fn->filename_tmp;
      case FILENAME_LINK:
        err = fil_sts(&(fn->link), fn->path, NULL, NULL);
        if (err < 0) {
          return "";
        }
        tcstoeucs(fn->filename_tmp, fn->path);
        return fn->filename_tmp;
      default:
        return "";
  }
}

int filename_is_null(Filename fn)
{
    return ((fn.tag == FILENAME_LINKNAME) && (!*fn.path));
}
