/* BTRON File I/O */

#ifndef DEFINE_H_BTRON_FILEIO
#define DEFINE_H_BTRON_FILEIO

#include <basic.h>
#include <btron/file.h>
#include "putty.h"

#define BTRON_FILEIO_BUFSIZE 1024

typedef enum {
  FILE_OPEN_UNKNOWN, FILE_OPEN_READ, FILE_OPEN_WRITE,
} FILE_open_type;

typedef struct {
  FILE_open_type open_type;
  W fd;
  B buf[BTRON_FILEIO_BUFSIZE];
  W record_size;
  int current_record_pos; /* not used when file-write */
  int buffer_start_index;
  int buffer_end_index;
  int recnum;
} FILE;

#ifndef GLOBAL_DEFINE_BTRON_FILEIO
FILE* f_open_rec(struct Filename filename, const char *mode, int is_private, int rectype);
extern int fflush(FILE *fp);
extern int fclose(FILE *fp);
extern size_t fread(B *ptr, size_t size, size_t nmemb, FILE *fp);
extern int fgetc(FILE *fp);
extern char* fgets(char *s, int size, FILE *fp);
extern TC* fgets_tc(TC* s, int size, FILE *fp);
extern size_t fwrite(const B* ptr, size_t size, size_t nmemb, FILE *fp);
extern int fputc(int c, FILE *fp);
extern int fputs(const char *s, FILE *fp);
#endif /* GLOBAL_DEFINE_BTRON_FILEIO */

static inline FILE* f_open(struct Filename filename, const char *mode, int is_private)
{
  return f_open_rec(filename, mode, is_private, 31);
}

#endif /* DEFINE_H_BTRON_FILEIO */
